SystemOrganization addCategory: #'JQueryMobile-Core-Document'!

WAHtmlRoot subclass: #JQMHtmlRoot
	instanceVariableNames: 'pageDivAttributes mobileInit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQueryMobile-Core-Document'!

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 08:29'!
addJQueryMobileHeadInfoUsing: rootForScriptRendering
	"see: http://jquerymobile.com/test/docs/pages/page-anatomy.html"
	
	"A jQuery Mobile site must start with an HTML5 'doctype' to take full advantage of all of the framework's features."
	self beHtml5. 
	
	JQGoogleLibrary default updateRoot: rootForScriptRendering.
	"mobileInit appears before the jQueryMobile library so that it can modify the defaults"
	self renderMobileInitOn: rootForScriptRendering.
	JQM10RC2Library default updateRoot: rootForScriptRendering.
	
	"The viewport setting below ensures the width will be set to the pixel width of the device screen"
	self meta name: 'viewport'; content: 'width=device-width, initial-scale=1'! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/25/2011 17:53'!
mobileInit
	^ mobileInit! !

!JQMHtmlRoot methodsFor: 'accessing' stamp: 'NickAger 10/25/2011 17:53'!
mobileInit: anObject
	mobileInit := anObject! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/25/2011 16:34'!
pageDivAttributes
	^ pageDivAttributes ifNil: [
		pageDivAttributes := WAHtmlAttributes new
			at: 'data-role' put: 'page';
			at: 'id' put: self session nextPageId;
			yourself ]
! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 08:28'!
renderJQueryMobileHeadInfo
	| rootForScriptRendering |
	rootForScriptRendering := JQMHtmlRoot context: self context.
	
	self addJQueryMobileHeadInfoUsing: rootForScriptRendering.
	
	rootForScriptRendering headElements reversed do: [ :each |
		self headElements addFirst: each ]! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 08:23'!
renderMobileInitOn: rootForScriptRendering
	self mobileInit notNil ifTrue: [
		String streamContents: [ :stream |
			| document  |
			document := WAHtmlDocument
				on: stream
				codec: self requestContext codec.
			self context document: document during: [ 
				| innerScript outerScript |
				innerScript := (JSScript context: self context)
					rendererClass: WARenderer;
					yourself.
					
				outerScript := (JSScript context: self context)
					rendererClass: WARenderer;
					yourself.

				self mobileInit value: innerScript.
				outerScript << outerScript jQuery jqmDocument onMobileInit: innerScript.
				rootForScriptRendering javascript add: outerScript asJavascript ] ] ]! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/25/2011 22:27'!
seasideAjaxRequestHeader
	^ '$($("html").ajaxSend(function(event, xhr, settings) { xhr.setRequestHeader("X-Requested-With", "jQueryMobile") }))'! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/20/2011 13:24'!
writeFootOn: aDocument
	aDocument closeTag: 'div'.
	super writeFootOn: aDocument! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/26/2011 08:21'!
writeHeadOn: aDocument
	self renderJQueryMobileHeadInfo.
	super writeHeadOn: aDocument.
	self writeSeasideAjaxRequestHeaderOn: aDocument.
	self writePageDivOn: aDocument! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/25/2011 18:17'!
writePageDivOn: aDocument
	aDocument nextPutAll: '<div'.
	self pageDivAttributes encodeOn: aDocument.

	"*Linking page>http://jquerymobile.com/test/docs/pages/page-links.html*"
	"jQueryMobile will update the URL with the url stored in 'data-url', when attached to the page's div. 
	This allows JQueryMobile to reflect redirects, see also: https://github.com/jquery/jquery-mobile/issues/1571"
	
	"add directly to the stream so that url parameters such as & isn't encoded as &amp;"
	aDocument 
		nextPutAll: ' data-url="';
		nextPutAll: self requestContext request url greaseString;
		nextPutAll: '">'
! !

!JQMHtmlRoot methodsFor: 'writing' stamp: 'NickAger 10/25/2011 22:27'!
writeSeasideAjaxRequestHeaderOn: aDocument
	aDocument scriptGenerator 
		writeScriptTag: [ 
			aDocument nextPutAll: self seasideAjaxRequestHeader ] 
		on: aDocument! !

!GRPackage class methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/26/2011 08:53'!
jQueryMobileCoreDocument
	^ self new
		name: 'JQueryMobile-Core-Document';
		description: 'jQueryMobile root renderer';
		addDependency:  'Seaside-Core';
		addDependency: 'Seaside-Session';
		addDependency:  'JQueryMobile-Libraries';
		addDependency: 'JQueryMobile-Scripting';
		url: #seasideUrl;
		yourself! !

!WASession methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/19/2011 15:10'!
currentPageId
	^ self idAsPageId: self pageId! !

!WASession methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/19/2011 15:09'!
idAsPageId: id
	^ 'pageId', id greaseString! !

!WASession methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/19/2011 15:10'!
nextPageId
	| pageId |
	pageId := self pageId.
	pageId := pageId + 1.
	self properties at: #pageId put: pageId.
	
	^ self idAsPageId: pageId ! !

!WASession methodsFor: '*jquerymobile-core-document' stamp: 'NickAger 10/19/2011 15:08'!
pageId
	^ self properties at: #pageId ifAbsent: [ 0 ]! !
